import { IAlgorithm, IChromosome, ITermination, IIsland, IMigration } from '..';
export declare abstract class AlgorithmBase implements IAlgorithm {
    protected readonly _bestChanged: undefined | (() => Promise<void>);
    private _chromosomes;
    private _fitness;
    private _best;
    protected constructor(_bestChanged?: undefined | (() => Promise<void>));
    get generationNumber(): number;
    get offspringNumber(): number;
    get initialized(): boolean;
    get chromosomes(): Array<IChromosome>;
    abstract get islands(): Array<IIsland>;
    get migration(): IMigration | undefined;
    abstract get termination(): ITermination;
    get best(): IChromosome;
    get progress(): number;
    get hasReached(): boolean;
    protected updateChromosomes(): Promise<void>;
    reset(): Promise<void>;
    protected performReset(): void;
    step(): Promise<void>;
    protected performStep(): void;
}
