"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopulationBase = void 0;
class PopulationBase {
    constructor(_size, _adamChromosome) {
        this._size = _size;
        this._adamChromosome = _adamChromosome;
        this._chromosomes = [];
    }
    get chromosomes() {
        return this._chromosomes;
    }
    get size() {
        return this._size;
    }
    init() {
        this._chromosomes = new Array();
        [...Array(this.size)].forEach(() => this._chromosomes.push(this._adamChromosome.createNew()));
        this.performInit();
    }
    performInit() {
        // override if required
    }
    async update(chromosomes) {
        if (this.size !== chromosomes.length) {
            throw new Error('Population size does not match the setting.');
        }
        this._chromosomes = Array.from(chromosomes);
    }
}
exports.PopulationBase = PopulationBase;
//# sourceMappingURL=PopulationBase.js.map